%global _description %{expand:
s2n-tls is a C99 implementation of the TLS/SSL protocols that is
designed to be simple, small, fast, and with security as a priority.}

Name:           s2n-tls
Version:        1.4.14
Release:        1%{?dist}
Summary:        A C99 implementation of the TLS/SSL protocols

License:        Apache-2.0
URL:            https://github.com/aws/s2n-tls
Source:         %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
# Install cmake files in 'libdir/cmake/s2n-tls' rather than 'libdir/s2n-tls/cmake'
Patch:          s2n-tls-cmake.patch

BuildRequires:  gcc
BuildRequires:  cmake
BuildRequires:  openssl-devel
BuildRequires:  ninja-build

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}
# Dependencies like aws-c-common don't support and build on s390x
# Upstream issue: https://github.com/awslabs/aws-c-common/issues/1111
# Fedora bugzilla ticket to be created after package review
ExcludeArch: s390x

%description %{_description}


%package devel
Summary:        %{summary}
Requires:       openssl-devel%{?_isa}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel %{_description}


%package doc
Summary:        %{summary}
BuildArch:      noarch

%description doc %{_description}


%prep
%autosetup -p1


%build
%cmake -GNinja -DBUILD_SHARED_LIBS=ON -DCMAKE_BUILD_TYPE=Release
%cmake_build


%install
%cmake_install
# install documentation
mkdir -p %{buildroot}/%{_docdir}/s2n-tls/docs
mkdir -p %{buildroot}/%{_docdir}/s2n-tls/docs/examples
mkdir -p %{buildroot}/%{_docdir}/s2n-tls/docs/images
install -p -m 644 docs/*.md %{buildroot}/%{_docdir}/s2n-tls/docs/
install -p -m 644 docs/examples/*.c %{buildroot}/%{_docdir}/s2n-tls/docs/examples/
install -p -m 644 docs/images/*.png %{buildroot}/%{_docdir}/s2n-tls/docs/images/
install -p -m 644 docs/images/*.svg %{buildroot}/%{_docdir}/s2n-tls/docs/images/


%check
%ctest


%files
%license LICENSE NOTICE
%doc README.md VERSIONING.rst
%{_libdir}/libs2n.so.1{,.*}


%files devel
%{_libdir}/libs2n.so
%{_includedir}/s2n.h
%{_includedir}/s2n/
%{_libdir}/cmake/s2n/


%files doc
%license LICENSE NOTICE
%dir %{_docdir}/s2n-tls/
%{_docdir}/s2n-tls/docs/


%changelog
* Wed May 15 2024 Dominik Wombacher <dominik@wombacher.cc> - 1.4.14-1
- update to 1.4.14

* Tue Sep 26 2023 Benson Muite <benson_muite@emailplus.org> - 1.3.51-1
- Initial packaging
